--[[
	cRefillAmmo
	Benihime aka Chimaine of EU-Blackrock
	GNUv2
]]
if select(2, UnitClass("player")) ~= "HUNTER" then
	return DisableAddOn("cRefillAmmo")
end

local cRefillAmmo = CreateFrame("Frame")

-------------------------------------------------------
--	Configuration
-------------------------------------------------------
local cfg = {
	confirm = true, -- true or false. If true, it will show a confirmation dialoge before refilling.
}

-------------------------------------------------------
--	do not edit from here on!
-------------------------------------------------------
local ammoBag, fAmmoSlots

local GetItemInfo = GetItemInfo
local BuyMerchantItem = BuyMerchantItem
local GetMerchantNumItems = GetMerchantNumItems
local GetMerchantItemInfo = GetMerchantItemInfo
local GetInventoryItemLink = GetInventoryItemLink
local GetContainerNumFreeSlots = GetContainerNumFreeSlots

local function print(text)
	DEFAULT_CHAT_FRAME:AddMessage("|cff7696bc c|rRefillAmmo: ".. tostring(text))
end

local function FindAmmoBag()
	for i = 0, NUM_BAG_SLOTS do
		local freeSlots, bagType = GetContainerNumFreeSlots(i)
		if freeSlots > 0 and bit.band(0x0003, bagType) > 0 then
			return i, freeSlots
		end
	end
end

local function GetPAmmoInfo()
	local ammoLink = GetInventoryItemLink("player", GetInventorySlotInfo("AmmoSlot"))
	local ammoName = GetItemInfo(ammoLink)
	return ammoName, ammoLink
end

local function MerchantHasAmmo()
	local pAmmoName, pAmmoLink = GetPAmmoInfo()
	for i = 1, GetMerchantNumItems() do
		local mAmmoName = GetMerchantItemInfo(i)
		if mAmmoName == pAmmoName then
			return i
		end
	end
end

local function BuyAmmo(mSlot)
	if not mSlot then
		mSlot = MerchantHasAmmo()
	end
	for i = 1, fAmmoSlots do
		BuyMerchantItem(mSlot)
	end
	ammoBag, fAmmoSlots = nil, nil
end

-------------------------------------------------------
--	Handler
-------------------------------------------------------
local MERCHANT_SHOW = function()
	ammoBag, fAmmoSlots = FindAmmoBag()
	
	if cfg.confirm == true then
		StaticPopupDialogs["CREFILLAMMO_MERCHANT1"].text = "|cff7696bc c|rRefill "..select(2,GetPAmmoInfo()).."?"
	end
	
	if ammoBag and fAmmoSlots ~= 0 then
		local hasAmmo = MerchantHasAmmo()
		if hasAmmo then
			if cfg.confirm then
				StaticPopup_Show("CREFILLAMMO_MERCHANT1")
			else
				BuyAmmo(hasAmmo)
			end
		end
	else
		ammoBag, fAmmoSlots = nil, nil
	end
end

-------------------------------------------------------
--	Popup
-------------------------------------------------------
if cfg.confirm == true then
	StaticPopupDialogs["CREFILLAMMO_MERCHANT1"] = {
		text = "|cff7696bc c|rRefill?",
		button1 = ACCEPT,
		button2 = CANCEL,
		OnAccept = function() BuyAmmo() end,
		timeout = 0,
		whileDead = 0,
		hideOnEscape = 1
	}
end

-------------------------------------------------------
--	Events/Scripts
-------------------------------------------------------
cRefillAmmo:RegisterEvent("MERCHANT_SHOW")
cRefillAmmo:SetScript("OnEvent", MERCHANT_SHOW)
